unit uTestSimplex;

{$IFDEF FPC}
  {$MODE Delphi}
{$ENDIF}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, uExcelFile, xMatDefs,
  uSimplex, uMIPSImplex,
  uConstantesSimSEE, uListaViolacionesPermitidasSimplex;

type
  TformTestSimplex = class(TForm)
    btAbrir: TButton;
    BTCerrar: TButton;
    OpenDialog1: TOpenDialog;
    BTActualizar: TButton;
    memo: TMemo;
    btContinuar: TButton;
    eCntLlamadas: TEdit;
    eCntHasta: TEdit;
    procedure btAbrirClick(Sender: TObject);
    procedure BTCerrarClick(Sender: TObject);
    procedure BTActualizarClick(Sender: TObject);
    procedure btContinuarClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    procedure abrirExcel(archi: string);
    procedure Procesar_DBGMONSPX(var Message: TMessage); message WM_DBGMONSPX;
    procedure ResolverReferenciasYCargarSimplex;
  public
    xf: TExcelFile;
    //    h: Variant;
    kfilx: integer; // fila de las x: en la planilla
    spx: TSimplex;
  end;

var
  formTestSimplex: TformTestSimplex;

implementation

{$IFNDEF FPC}
  {$R *.dfm}

{$ELSE}
  {$R *.lfm}
{$ENDIF}

procedure TformTestSimplex.abrirExcel(archi: string);
begin
  btAbrir.Enabled := False;
  xf := TExcelFile.Create('', False, True, False);
  xf.Abrir(archi);
  ResolverReferenciasYCargarSimplex;
  xf.VisibleOn;
  spx.Resolver;
end;

procedure TformTestSimplex.Procesar_DBGMONSPX(var Message: TMessage);
var
  ts: string;
  cntLLamadas, cntHasta: integer;
begin
  cntLlamadas := StrToInt(ecntLlamadas.Text);
  Inc(cntLlamadas);
  ecntLlamadas.Text := IntToStr(cntLlamadas);
  cntHasta := StrToInt(ecntHasta.Text);

  ts := ecntLlamadas.Text + '::>' + dbgmonspx_LeerMensaje;
  memo.Lines.Append(ts);
  if cntLlamadas <= cntHasta then
    btContinuarClick(self)
  else
    btContinuar.Enabled := True;
end;

procedure TformTestSimplex.btAbrirClick(Sender: TObject);
begin
  if OpenDialog1.Execute then
  begin
    abrirExcel(OpenDialog1.FileName);
  end;
end;

procedure TformTestSimplex.BTCerrarClick(Sender: TObject);
begin
  if assigned(xf) then
  begin
    xf.Free;
    xf := nil;
    dbgmonspx_Abortar;
  end;
  btAbrir.Enabled := True;
end;

procedure TformTestSimplex.ResolverReferenciasYCargarSimplex;
var
  jcol: integer;
  buscando: boolean;
  r: string;
  cnt_Variables, cnt_Restricciones: integer;

  k, j: integer;
  ivae1, ivae2: string;

  lstve: TDAOfNInt;
  xlstAcoplesVEnts: TDAOfAcoplesVEnts;
  NEnteras, nViolacionesPermitidas, nViolacionesUsadas, cnt_RestrRedundantes: integer;
  ficha: TFichaViolacionPermitida;
  nIvars: integer;
  iVars: TDAofNInt;
  listaViolacionesPermitidas: TListaViolacionesPermitidasSimplex;
begin
  kfilx := 1;
  jcol := 1;

  xf.ActivoHoja_numero(1);

  kfilx := 2;
  r := xf.readStr(kfilx, 1);
  if pos('NEnteras:', r) = 1 then
  begin
    NEnteras := xf.readInt(kfilx, 2);
    setlength(lstve, NEnteras);
    for k := 0 to high(lstve) do
      lstve[k] := xf.readInt(kfilx, 3 + k);
    //paso la lista de variables enteras y el ivae VarAcoplada ResAcoplada
    kfilx := kfilx + 2;
    setLength(xlstAcoplesVEnts, NEnteras);
    for k := 0 to high(xlstAcoplesVEnts) do
    begin
      j := 1;
      ivae1 := xf.readStr(kfilx, 1);
      ivae2 := xf.readStr(kfilx + j, 1);
      while (ivae1 = ivae2) do
      begin
        Inc(j);
        ivae2 := xf.readStr(kfilx + j, 1);
      end;
      setLength(xlstAcoplesVEnts[k], j);
      for j := 0 to high(xlstAcoplesVEnts[k]) do
      begin
        xlstAcoplesVEnts[k][j].ivar := xf.readInt(kfilx + j, 2);
        xlstAcoplesVEnts[k][j].ires := xf.readInt(kfilx + j, 3);
      end;
      kfilx := kfilx + length(xlstAcoplesVEnts[k]);
    end;
  end
  else
    NEnteras := 0;

  //cnt_varfijas
  kfilx := kfilx + 1;
  cnt_RestrRedundantes := xf.ReadInt(kfilx, 2);
  kfilx := kfilx + 1;
  listaViolacionesPermitidas := TListaViolacionesPermitidasSimplex.Create;
  nViolacionesUsadas := xf.ReadInt(kfilx, 2);
  kfilx := kfilx + 2;//cnt_ViolacionesUsadas, violacionesPermitidas
  nViolacionesPermitidas := xf.ReadInt(kfilx, 2);
  listaViolacionesPermitidas.Capacity := nViolacionesPermitidas;
  kfilx := kfilx + 1;//ivar  ires  usada
  for k := 1 to nViolacionesPermitidas do
  begin
    nIvars := xf.ReadInt(kfilx + k, 4);
    SetLength(iVars, nIvars);
    for j := 0 to high(iVars) do
      iVars[j] := xf.ReadInt(kfilx + k, 5 + j);

    ficha := TFichaViolacionPermitida.Create(xf.ReadInt(kfilx + k, 1), iVars);
    ficha.usada := xf.ReadInt(kfilx + k, 2) <> 0;
    ficha.iViolacionAUsar := xf.ReadInt(kfilx + k, 3);
    listaViolacionesPermitidas.Add(ficha);
  end;

  buscando := True;
  kfilx := 1;
  jcol := 1;
  xf.ActivoHoja_numero(1);
  while buscando and (kfilx < 100) do
  begin
    r := xf.ReadStr(kfilx, 1);
    if pos('x:', r) = 1 then
      buscando := False
    else
      Inc(kfilx);
  end;

  if buscando then
    raise Exception.Create('No encontr la fila del asl x: ');

  // contamos las variables
  cnt_Variables := 0;
  jcol := 2;
  r := xf.ReadStr(kfilx, jcol);
  while r <> '' do
  begin
    Inc(cnt_Variables);
    Inc(jcol);
    r := xf.ReadStr(kfilx, jcol);
  end;

  // contamos las restricciones
  cnt_Restricciones := 0;
  jcol := 2;
  r := xf.ReadStr(kfilx + 4, jcol);
  while r <> '' do
  begin
    Inc(cnt_Restricciones);
    Inc(jcol);
    r := xf.ReadStr(kfilx + 4, jcol);
  end;

  //creamos el simplex
  spx := TMIPSimplex.Create_init(cnt_Restricciones + 1, cnt_Variables + 1,
    NEnteras, nil, nil);

  spx.cnt_RestriccionesRedundantes_ := cnt_RestrRedundantes;
  spx.violacionesPermitidas.Free;
  spx.violacionesPermitidas := listaViolacionesPermitidas;
  spx.cnt_ViolacionesUsadas := nViolacionesUsadas;

  for j := 1 to cnt_Variables do
    spx.top[j] := xf.ReadInt(kfilx + 5, j + 1);

  for j := 1 to cnt_Restricciones do
    spx.left[j] := xf.ReadInt(kfilx + 6, j + 1);

  spx.rearmarIndicesiiXiiY;

  // ahora leemos las variables y sus cotas
  spx.cnt_varfijas := 0;
  for j := 1 to cnt_Variables do
  begin
    spx.x_inf.pv[j] := xf.ReadFloat(kfilx + 1, j + 1);
    spx.x_sup.pv[j] := xf.ReadFloat(kfilx + 2, j + 1);
    spx.flg_x[j] := xf.ReadInt(kfilx + 3, j + 1);
    if abs(spx.flg_x[j]) = 2 then
      Inc(spx.cnt_varfijas);
    spx.nombreVars[j] := xf.ReadStr(kfilx, j + 1);
  end;

  //  TMIPSimplex(spx).lstAcoplesVEnts:= xlstAcoplesVEnts;
  for j := 1 to NEnteras do
  begin
    if xlstAcoplesVEnts[j - 1][0].ivar <> -1 then
      TMIPSimplex(spx).set_EnteraConAcoples(j, lstve[j - 1], trunc(
        spx.x_sup.pv[lstve[j - 1]] + 0.1),
        xlstAcoplesVEnts[j - 1])
    else
      spx.set_entera(j, lstve[j - 1], trunc(spx.x_sup.pv[lstve[j - 1]] + 0.1));
  end;

  // cargamos las flg_y
  spx.cnt_igualdades := 0;
  for j := 1 to cnt_Restricciones do
  begin
    spx.flg_y[j] := xf.ReadInt(kfilx + 4, j + 1);
    if abs(spx.flg_y[j]) = 2 then
      Inc(spx.cnt_igualdades);
    if spx.iiy[j] > 0 then
      spx.nombreRest[j] := xf.ReadStr(kfilx + 10 + spx.iiy[j], 1)
    else
      spx.nombreRest[j] := xf.ReadStr(kfilx + 10, 1 - spx.iiy[j]);
  end;

  // cargamos la matriz
  for k := 1 to cnt_Restricciones + 1 do
    for j := 1 to cnt_Variables + 1 do
    begin
      spx.pon_e(k, j, xf.ReadFloat(kfilx + 10 + k, j + 1));
    end;
end;

procedure TformTestSimplex.BTActualizarClick(Sender: TObject);
var
  k, j: integer;
  spx: TSimplex;
  cursorAnterior: TCursor;
begin
  spx := umipsimplex.spxActivo;
  if spx = nil then
    exit;
  BTContinuar.Enabled := False;
  cursorAnterior := screen.Cursor;
  Screen.Cursor := crHourGlass;

  xf.Write(kfilx - 3, 2, spx.cnt_varfijas);
  xf.Write(kfilx - 2, 2, spx.cnt_RestriccionesRedundantes_);
  //Cotas y flgs_x
  for j := 1 to spx.nc - 1 do
  begin
    xf.Write(kfilx + 1, j + 1, spx.x_inf.pv[j]);
    xf.Write(kfilx + 2, j + 1, spx.x_sup.pv[j]);
    xf.Write(kfilx + 3, j + 1, spx.flg_x[j]);
  end;

  //flgs_y
  for j := 1 to spx.nf - 1 do
  begin
    xf.Write(kfilx + 4, j + 1, spx.flg_y[j]);
  end;

  //Top y left
  for j := 1 to spx.nc - 1 do
    xf.Write(kfilx + 5, j + 1, spx.top[j]);
  for j := 1 to spx.nf - 1 do
    xf.Write(kfilx + 6, j + 1, spx.left[j]);

  //Encabezados de las variables
  for j := 1 to spx.nc do
    if spx.top[j] < 0 then
      xf.Write(kfilx + 10 + 0, j + 1, spx.nombreVars[-spx.top[j]])
    else
      xf.Write(kfilx + 10 + 0, j + 1, spx.nombreRest[spx.top[j]]);

  //Nombres de las restricciones y valores que tienen que cumplir
  for k := 1 to spx.nf - 1 do
    if spx.left[k] > 0 then
    begin
      //Es una y
      xf.Write(kfilx + 10 + k, 1, spx.nombreRest[spx.left[k]]);
      case spx.flg_y[spx.left[k]] of
        0:
        begin
          xf.Write(kfilx + 10 + k, 1 + spx.nc + 1, '>= 0');
          xf.Write(kfilx + 10 + k, 1 + spx.nc + 2, '');
        end;
        2:
        begin
          xf.Write(kfilx + 10 + k, 1 + spx.nc + 1, '= 0');
          xf.Write(kfilx + 10 + k, 1 + spx.nc + 1, '');
        end;
        -2:
        begin
          xf.Write(kfilx + 10 + k, 1 + spx.nc + 1, '= 0');
          xf.Write(kfilx + 10 + k, 1 + spx.nc + 1, '');
        end;
        else
          //Cota superior de una restriccion??
          xf.Write(kfilx + 10 + k, 1 + spx.nc + 1, '??, flg_y=' + IntToStr(spx.flg_y[spx.left[k]]));
      end; // case
    end
    else
    begin
      //Es una x
      xf.Write(kfilx + 10 + k, 1, spx.nombreVars[-spx.left[k]]);
      case spx.flg_x[-spx.left[k]] of
        -1, 1:
        begin
          xf.Write(kfilx + 10 + k, 1 + spx.nc + 1, '>= 0');
          xf.Write(kfilx + 10 + k, 1 + spx.nc + 2, '<= ' +
            FloatToStr(spx.x_sup.e(-spx.left[k])));
        end;
        -2, 2:
        begin
          //                if pos('=', h.cells[kfilx+10+k, 1+spx.nc+2]) <> 0 then
          xf.Write(kfilx + 10 + k, 1 + spx.nc + 2, ' ');
          xf.Write(kfilx + 10 + k, 1 + spx.nc + 1, '= 0');
          // + FloatToStr(spx.x_inf.e(-spx.left[k]));
        end;
        0:
        begin
          //            if pos('=', h.cells[kfilx+10+k, 1+spx.nc+2]) <> 0 then
          xf.Write(kfilx + 10 + k, 1 + spx.nc + 2, ' ');
          xf.Write(kfilx + 10 + k, 1 + spx.nc + 1, '>= 0');
        end
      end; //  case
    end;
  xf.Write(kfilx + 10 + spx.nf, 1, 'z');

  for k := 1 to spx.nf do
    for j := 1 to spx.nc do
    begin
      //      h.cells[kfilx+10+k, j+1]:= spx.e(k, j);
      xf.Write(kfilx + 10 + k, j + 1, spx.e(k, j));
      if abs(spx.e(k, j)) > 1E15 then
        memo.Lines.Add('OJO: abs(spx[' + IntToStr(k) + ', ' + IntToStr(j) + ']) > 1E15');
    end;
  BTContinuar.Enabled := True;
  Screen.Cursor := cursorAnterior;
end;

procedure TformTestSimplex.btContinuarClick(Sender: TObject);
begin
  btContinuar.Enabled := False;
  dbgmonspx_Continuar;
end;

procedure TformTestSimplex.FormCreate(Sender: TObject);
begin
  usimplex.dbgmonspx_RegistrarMonitor(Handle);
  xf := nil;
  OpenDialog1.InitialDir := getDir_Dbg;
  if ParamCount >= 1 then
  begin
    if FileExists(ParamStr(1)) then
    begin
      OpenDialog1.FileName := ParamStr(1);
      //    abrirExcel(OpenDialog1.FileName);
      if ParamCount >= 2 then
      begin
        try
          StrToInt(ParamStr(2));
          eCntHasta.Text := ParamStr(2);
        except
          //Ignoro el parmetro
        end;
      end;
    end;
  end;
end;

procedure TformTestSimplex.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  BTCerrarClick(BTCerrar);
  if xf <> nil then
  begin
    xf.Free;
    xf := nil;
    dbgmonspx_RegistrarMonitor(0);
    dbgmonspx_Continuar;
  end;
end;

end.
