unit uFrameEditCosa;

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, ExtCtrls, StdCtrls, EditBtn,
  ucosa;

type

  { TControlOfCosa }

  TControlOfCosa=class(TPanel)
  public
    LabelCaption:string;
    tlPoint:TPoint;
    brPoint:TPoint;
    constructor Create(TheOwner: TComponent; DataColumn: TDataColumnOfCosa); virtual;
    function Place(xPoint: TPoint): TPoint;
  end;

  { TControlLabelEditOfCosa }

  TControlLabelEditOfCosa=class(TControlOfCosa)
    constructor Create(TheOwner: TComponent; DataColumn: TDataColumnOfCosa); override;
  end;

  { TControlCheckBoxOfCosa }

  TControlCheckBoxOfCosa=class(TControlOfCosa)
    constructor Create(TheOwner: TComponent; DataColumn: TDataColumnOfCosa); override;
  end;

  { TControlLabelComboBoxOfCosa }

  TControlLabelComboBoxOfCosa=class(TControlOfCosa)
    constructor Create(TheOwner: TComponent; DataColumn: TDataColumnOfCosa); override;
  end;

  { TControlButtomOfCosa }

  TControlButtomOfCosa=class(TControlOfCosa)
    constructor Create(TheOwner: TComponent; DataColumn: TDataColumnOfCosa); override;
  end;

  { TControlLabelGridOfCosa }

  TControlLabelGridOfCosa=class(TControlOfCosa)
    constructor Create(TheOwner: TComponent; DataColumn: TDataColumnOfCosa); override;
  end;

  { TControlLabelDateEditOfCosa }

  TControlLabelDateEditOfCosa=class(TControlOfCosa)
    constructor Create(TheOwner: TComponent; DataColumn: TDataColumnOfCosa); override;
  end;



  { TFrameEditCosa }

  TFrameEditCosa = class(TFrame)
  private
    { private declarations }
    _dataColumnList: TDataColumnListOfCosa;
  public
    { public declarations }

    ControlList:TList;

    constructor Create (TheOwner: TComponent; ClaseDeCosa: TClaseDeCosa);
    procedure AfterConstruction; override;

    procedure CreateControlList;
    procedure PlaceControlList;

    procedure frameFichasLPD;


 end;

const
  TopSeparetion=5;
  LeftSeparation=5;

implementation

{$R *.lfm}

{ TControlLabelDateEditOfCosa }

constructor TControlLabelDateEditOfCosa.Create(TheOwner: TComponent;
  DataColumn: TDataColumnOfCosa);
begin
  inherited Create(TheOwner, DataColumn);
end;

{ TControlLabelGridOfCosa }

constructor TControlLabelGridOfCosa.Create(TheOwner: TComponent;
  DataColumn: TDataColumnOfCosa);
begin
  inherited Create(TheOwner, DataColumn);
end;

{ TControlButtomOfCosa }

constructor TControlButtomOfCosa.Create(TheOwner: TComponent;
  DataColumn: TDataColumnOfCosa);
begin
  inherited Create(TheOwner, DataColumn);
end;

{ TControlLabelComboBoxOfCosa }

constructor TControlLabelComboBoxOfCosa.Create(TheOwner: TComponent;
  DataColumn: TDataColumnOfCosa);
begin
  inherited Create(TheOwner, DataColumn);
end;

{ TControlOfCosa }

constructor TControlOfCosa.Create(TheOwner: TComponent;
  DataColumn: TDataColumnOfCosa);
begin

  inherited Create(TheOwner);

  if (DataColumn.LabelCaption <> '') then
    LabelCaption:=DataColumn.LabelCaption
  else
    LabelCaption:=DataColumn.ColumnName;
  LabelCaption:=LabelCaption+': ';
end;

function TControlOfCosa.Place(xPoint: TPoint): TPoint;
begin
  self.Left:=xPoint.x;
  self.Top:=xPoint.y;
end;

{ TControlCheckBoxOfCosa }

constructor TControlCheckBoxOfCosa.Create(TheOwner: TComponent;
  DataColumn: TDataColumnOfCosa);
var
  xCheckBox:TCheckBox;
begin
  inherited Create(TheOwner, DataColumn);

  xCheckBox:= TCheckBox.Create(self);
  xCheckBox.Parent:=self;
  xCheckBox.Name:='cb_'+DataColumn.ColumnName;
  xCheckBox.Caption:=caption;
  xCheckBox.Top:=top;
  xCheckBox.Left:=left;

  brPoint.x:=xCheckBox.Width;
  brPoint.y:=xCheckBox.Height;

end;

{ TControlLabelEditOfCosa }

constructor TControlLabelEditOfCosa.Create(TheOwner: TComponent;
  DataColumn: TDataColumnOfCosa);
var
  xLabel:TLabel;
  xEdit:TEdit;
  xPoint:TPoint;
begin

  inherited Create(TheOwner, DataColumn);

  xLabel:=TLabel.Create(self);
  xLabel.Parent:=self;
  xLabel.Name:= 'l_'+DataColumn.ColumnName;
  xLabel.Caption:=LabelCaption;
  xLabel.Top:=top+4;
  xLabel.Left:=left;
  xLabel.Width:=(Length(caption)+2)*6;

  xEdit:=TEdit.Create(self);
  xEdit.Parent:=self;
  xEdit.Name:= 'e_'+DataColumn.ColumnName;
  xEdit.Top:=top;
  xEdit.Text:='';
  xEdit.Left:=xLabel.Left + xLabel.Width + LeftSeparation;

  xPoint.x:=xEdit.Left+XEdit.Width-xLabel.Left;
  xPoint.y:=xEdit.Height;

end;

{ TFrameEditCosa }

constructor TFrameEditCosa.Create(TheOwner: TComponent;
  ClaseDeCosa: TClaseDeCosa);
begin
  inherited Create(TheOwner);
  _DataColumnList:= ClaseDeCosa.CreateDataColumnList();
  self.Top:=TopSeparetion;
  self.Left:=LeftSeparation;
end;

procedure TFrameEditCosa.AfterConstruction;
begin
  CreateControlList;
  PlaceControlList;
end;

procedure TFrameEditCosa.CreateControlList;
var
  i: Integer;
  DataColumn:TDataColumnOfCosa;
  xControlOfCosa:TControlOfCosa;
begin

  self.ControlList := TList.Create;
  for i:=0 to _DataColumnList.Count-1 do
    begin
      DataColumn := _DataColumnList[i];

      if DataColumn.DataType is TDataTypeCardinalOfCosa or
        DataColumn.DataType is TDataTypeIntegerOfCosa or
          DataColumn.DataType is TDataTypeDoubleOfCosa or
            DataColumn.DataType is TDataTypeStringOfCosa then
      begin
        xControlOfCosa:=TControlLabelEditOfCosa.Create(self, DataColumn);
      end
      else if DataColumn.DataType is TDataTypeBooleanOfCosa then
      begin
        xControlOfCosa:=TControlCheckBoxOfCosa.Create(self, DataColumn);
      end
      else if DataColumn.DataType is TDataTypeDataRowOfCosa then
      begin
        xControlOfCosa:=TControlButtomOfCosa.Create(self, DataColumn);
      end
      else if DataColumn.DataType is TDataTypeListOfCosa then
      begin
        xControlOfCosa:=TControlLabelGridOfCosa.Create(self, DataColumn);
      end
      else if DataColumn.DataType is TDataTypeDateOfCosa then
      begin
        xControlOfCosa:=TControlLabelDateEditOfCosa.Create(self, DataColumn);
      end;

      self.ControlList.Add(xControlOfCosa);
    end;

end;

procedure TFrameEditCosa.PlaceControlList;
var
  i: Integer;
  control: TControlOfCosa;
  xltPoint: TPoint;
  xbrPoint: TPoint;
begin

  xltPoint.x:=LeftSeparation;
  xltPoint.y:=TopSeparetion;

  for i:= 0 to ControlList.Count-1 do
    begin
      control:= TControlOfCosa(ControlList.Items[i]);
      xbrPoint:=control.Place(xltPoint);
      self.InsertControl(control);
      xltPoint.y:=xltPoint.y+xbrPoint.y+TopSeparetion;
    end;
end;

procedure TFrameEditCosa.frameFichasLPD;
begin

end;

end.

