unit uVirtualTablesDefs;
{$mode delphi}
interface

uses
  Classes, SysUtils, ucosa,
  uActores,
  uGeneradores,
  uGTer,
  uParqueEolico, uParqueEolico_vxy,
  usolartermico, usolarpv,
  uDemandas,
  unodos, uArcos,
  uComercioInternacional,
  uFuentesAleatorias,
  uescenarios;

type

  { TVirtualDataTablesList }

  { TVDataColumn }

  { TDataVColumn }

  TDataVColumn=class(TDataColumnOfCosa)
  public
    ReadOnly:boolean;
    constructor Create(xColumnName:string; xDataType:DataTypeOfCosa; xReadOnly:boolean);
  end;

  TVirtualDataTablesList=class
  private
    lst:TList;

    function Get(Index: Integer): TDataVTableOfCosa;
  public

    constructor Create;
    function Add (vdt: TDataVTableOfCosa):Integer;
    function GetVirtualTable (TableName:string):TDataVTableOfCosa;
    function Count: Integer;
    property Item[Index: Integer]:TDataVTableOfCosa read Get;default;
  end;

  { TVirtualTableActores }

  TVirtualTableActores=class(TDataVTableOfCosa)
    constructor Create(TableName: string);
  end;

var
  VirtualTables: TVirtualDataTablesList;

procedure AddChildClassToVirtualTable(VirtualTableName:string; AChildClass: TClaseDeCosa);

procedure CreateVirtualTables();

procedure AlInicio;

implementation

procedure AddChildClassToVirtualTable(VirtualTableName:string;
  AChildClass: TClaseDeCosa);
var
  VirtualTable: TDataVTableOfCosa;
begin
  VirtualTable:=VirtualTables.GetVirtualTable(VirtualTableName);
  //if not Assigned(VirtualTable) then
  //begin
  //  VirtualTable := TVirtualTableActores.Create(VirtualTableName);
  //  VirtualTables.Add(VirtualTable);
  //end;
  VirtualTable.AddChildClassName(AChildClass.ClassName);

end;

procedure CreateVirtualTables;
var
  i:integer;
  ClaseDeCosa:TClaseDeCosa;
begin

  VirtualTables.Add(TVirtualTableActores.Create('vdt_'+TActor.ClassName));
  VirtualTables.Add(TVirtualTableActores.Create('vdt_'+TGenerador.ClassName));
  VirtualTables.Add(TVirtualTableActores.Create('vdt_'+TGTer.ClassName));
  VirtualTables.Add(TVirtualTableActores.Create('vdt_'+TGeneradorHidraulico.ClassName));
  VirtualTables.Add(TVirtualTableActores.Create('vdt_'+TParqueEolico.ClassName));
  VirtualTables.Add(TVirtualTableActores.Create('vdt_'+TSolarPV.ClassName));
  VirtualTables.Add(TVirtualTableActores.Create('vdt_'+TDemanda.ClassName));
  VirtualTables.Add(TVirtualTableActores.Create('vdt_'+TNodo.ClassName));
  VirtualTables.Add(TVirtualTableActores.Create('vdt_'+TComercioInternacional.ClassName));
  VirtualTables.Add(TVirtualTableActores.Create('vdt_'+TFuenteAleatoria.ClassName));

  for i:=0 to registro_de_ClasesDeCosas_.Count-1 do
  begin

    ClaseDeCosa := TClaseDeCosa(TFichaClase(registro_de_ClasesDeCosas_.items[i]).clase);

    if IsChild(TEscenario_rec, ClaseDeCosa) then
      //Lista de Escenarios
      AddChildClassToVirtualTable('vdt_'+TEscenario_rec.ClassName, ClaseDeCosa);

    if IsChild(TActor, ClaseDeCosa) then
      //Lista de Actores
      AddChildClassToVirtualTable('vdt_'+TActor.ClassName, ClaseDeCosa);
    if IsChild(TGenerador, ClaseDeCosa) then
    begin
      //Lista de Generadodes
      AddChildClassToVirtualTable('vdt_'+TGenerador.ClassName, ClaseDeCosa);
      if IsChild(TGTer, ClaseDeCosa) then
        //Lista de Generadores Termicos
        AddChildClassToVirtualTable('vdt_'+TGTer.ClassName, ClaseDeCosa)
      else if IsChild(TGeneradorHidraulico, ClaseDeCosa) then
        //Lista de Generadores Hidraulicos
        AddChildClassToVirtualTable('vdt_'+TGeneradorHidraulico.ClassName, ClaseDeCosa)
      else if (IsChild(TParqueEolico, ClaseDeCosa) or IsChild(TParqueEolico_vxy, ClaseDeCosa)) then
        //Lista de Generadores Eolicos
        AddChildClassToVirtualTable('vdt_'+TParqueEolico.ClassName, ClaseDeCosa)
      else if (IsChild(TSolarPV, ClaseDeCosa) or IsChild(TSolarTermico, ClaseDeCosa)) then
        //Lista de Generadores Solares
        AddChildClassToVirtualTable('vdt_'+TSolarPV.ClassName, ClaseDeCosa)
    end
    else if IsChild(TDemanda, ClaseDeCosa) then
      //Lista de Demandas
      AddChildClassToVirtualTable('vdt_'+TDemanda.ClassName, ClaseDeCosa)
    else if (IsChild(TNodo, ClaseDeCosa) or IsChild(TArco, ClaseDeCosa)) then
      //Red Electrica
      AddChildClassToVirtualTable('vdt_'+TNodo.ClassName, ClaseDeCosa)
    else if IsChild(TComercioInternacional, ClaseDeCosa) then
      // Comercio Internacional
      AddChildClassToVirtualTable('vdt_'+TComercioInternacional.ClassName, ClaseDeCosa)
    else if IsChild(TFuenteAleatoria, ClaseDeCosa) then
      //Lista de Fuentes
      AddChildClassToVirtualTable('vdt_'+TFuenteAleatoria.ClassName, ClaseDeCosa)
    end;
end;

procedure AlInicio;
var
  i: Integer;
  ClaseDeCosa: TClaseDeCosa;
begin

  //vdt_TListGeneradorCO2

  VirtualTables.Add(TDataVTableOfCosa.Create('vdt_TListGeneradorCO2'));
  VirtualTables.Item[VirtualTables.Count-1].AddDataColumn(TDataVColumn.Create('nombre', TDataTypeStringOfCosa, true));
  VirtualTables.Item[VirtualTables.Count-1].AddDataColumn(TDataVColumn.Create('nacimiento', TDataTypeDateOfCosa, true));
  VirtualTables.Item[VirtualTables.Count-1].AddDataColumn(TDataVColumn.Create('TonCO2xMWh', TDataTypeDoubleOfCosa, false));
  VirtualTables.Item[VirtualTables.Count-1].AddDataColumn(TDataVColumn.Create('LowCostMustRun', TDataTypeBooleanOfCosa, false));
  VirtualTables.Item[VirtualTables.Count-1].AddDataColumn(TDataVColumn.Create('CleanDevelopmentMechanism', TDataTypeBooleanOfCosa, false));
  for i:=0 to registro_de_ClasesDeCosas_.Count-1 do
  begin
    ClaseDeCosa:=TClaseDeCosa(TFichaClase(registro_de_ClasesDeCosas_.items[i]).clase);
    if IsChild(TGenerador, ClaseDeCosa) then
    begin
      AddChildClassToVirtualTable(VirtualTables.Item[VirtualTables.Count-1].TableName, ClaseDeCosa);
    end;
  end;

  VirtualTables.Add(TDataVTableOfCosa.Create('vdt_TListEscenario'));
  VirtualTables.Item[VirtualTables.Count-1].AddDataColumn(TDataVColumn.Create('nombre', TDataTypeStringOfCosa, true));
  AddChildClassToVirtualTable(VirtualTables.Item[VirtualTables.Count-1].TableName, TEscenario_rec);

  CreateVirtualTables;

  for i:=0 to VirtualTables.Count-1 do
  begin
    ucosa.DATA_STORE.AddDataTable(VirtualTables[i]);
   end;


end;

{ TDataVColumn }

constructor TDataVColumn.Create(xColumnName: string; xDataType: DataTypeOfCosa;
  xReadOnly: boolean);
begin
  self.ColumnName:=xColumnName;
  self.DataType:=xDataType.Create(Self);
  self.ReadOnly:=xReadOnly;
end;

{ TVirtualTableActores }

constructor TVirtualTableActores.Create(TableName: string);
var
  DataVColumnList: TDataColumnListOfCosa;
begin
  DataVColumnList:=TDataColumnListOfCosa.Create();
  DataVColumnList.AddDataColumn('nombre', TDataTypeStringOfCosa);

  inherited Create(TableName, DataVColumnList);

end;

{ TVirtualDataTablesList }

function TVirtualDataTablesList.Get(Index: Integer): TDataVTableOfCosa;
begin
  Result:=lst.Items[Index];
end;

constructor TVirtualDataTablesList.Create;
begin
  lst:=TList.Create;
end;

function TVirtualDataTablesList.Add(vdt: TDataVTableOfCosa): Integer;
begin
  Result := lst.Add(vdt);
end;

function TVirtualDataTablesList.GetVirtualTable(TableName:string): TDataVTableOfCosa;
var
  i: Integer;
  vdt: TDataVTableOfCosa;
begin
  Result:=nil;
  for i:=0 to lst.Count-1 do
  begin
    vdt:=TDataVTableOfCosa(lst.Items[i]);
    if LowerCase(vdt.TableName)=LowerCase(TableName) then
    begin
      Result:=vdt;
      Break;
    end;
  end;
end;

function TVirtualDataTablesList.Count: Integer;
begin
  Result:=lst.Count;
end;

initialization
  VirtualTables:= TVirtualDataTablesList.Create;

finalization
  VirtualTables.Free;

end.

