program tminer;
uses
	xMatDefs, MatReal, {$I xCrt}, miner3, miner;

const
	pasoini= 1;
	errx= 1e-12;
	MaxNITersrel= 100;
	MaxNIters= 10000;


function costo( kf: integer; var X: TVectR ): NReal; far;
var
	m: NReal;
begin
	m:= X.e(1) + X.e(2);
	costo:= m;
end;

procedure grad( kf: integer;  var g, x: TVectR); far;
begin
	g.pon_e(1, 1);
	g.pon_e(2, 1);
end;


function fr1( kf: integer;  var X: TVectR ): NReal; far;
var
	m: NReal;
begin
	m:= 1-X.e(1);
	fr1:= m;
end;

procedure gr1( kf: integer;  var g, x: TVectR); far;
begin
	g.pon_e(1, -1);
	g.pon_e(2, 0);
end;

function fr2( kf: integer;  var X: TVectR ): NReal; far;
var
	m: NReal;
begin
	m:= 2-X.e(2);
	fr2:= m;
end;

procedure gr2( kf: integer;  var g, x: TVectR); far;
begin
	g.pon_e(1, 0);
	g.pon_e(2, -1);
end;

procedure DefinirProblema;
begin
	Miner3.Init( 2, 2 );
	DefFunc( 0, costo, grad );
	DefFunc( 1, fr1, gr1 );
	DefFunc( 2, fr2, gr2 );
end;




var
	x: TVectR;
	NIters, NItersRel: longint;
	ValCosto: NReal;
	Convergio: boolean;




begin
	DefinirProblema;
	x.init( 2);
	x.pon_e( 1, 10 );
	x.pon_e( 2, 10 );

	Minimizar(
		X, pasoini, errx,
		MaxNitersrel,	NItersRel,
		MaxNIters, NIters,
		ValCosto, Convergio );

	write(  'NIr: ', NItersRel:4);
	if convergio then
		writeln( '  x1: ',X.e(1):8:-4, '  x2: ', X.e(2):8:-4,' f(x): ', ValCosto:8:-4 )
	else
		writeln( '  NO CONVERGIO ');


	x.done;
	Miner3.done;
end.
